<script setup lang="ts">
import { ref, computed } from "vue";
import { useWindowSize, useCssVar } from "@vueuse/core";
import { useGallery } from "@/stores/gallery";
import LogoImg from "@/assets/images/logo.svg?component";
import IconsUrl from "@/assets/images/icons.svg";
import BaseButton from "@/components/BaseButton.vue";
import ImageUploader from "@/components/ImageUploader.vue";

const galleryStore = useGallery();

const semiSmallScreenWidth = computed(() => {
  const propName = "--semi-small-screen__width";
  const propEmValue = useCssVar(propName).value.slice(0, -2);
  const pxValue = Number(propEmValue) * 16;
  return pxValue;
});

const { width: windowWidth } = useWindowSize();

const showUpload = ref(false);
</script>

<template>
  <ImageUploader v-if="showUpload" @finish="() => (showUpload = false)" />
  <header class="header">
    <section class="logo">
      <LogoImg class="logo__icon" />

      <h1 class="logo__text">Unslash</h1>
    </section>
    <section class="search">
      <svg class="search__icon"><use :href="`${IconsUrl}#search`" /></svg>
      <input
        class="search__input"
        placeholder="Search by label"
        aria-label="Search images by their label"
        v-model="galleryStore.labelFilter"
      />
    </section>
    <BaseButton
      class="button"
      :class="{
        'button--with-text': windowWidth > semiSmallScreenWidth,
        'button--with-icon': windowWidth <= semiSmallScreenWidth,
      }"
      @click="() => (showUpload = true)"
      aria-label="Add a photo"
    >
      <span v-if="windowWidth > semiSmallScreenWidth" aria-hidden="true"
        >Add a photo</span
      >
      <svg v-else class="button__icon">
        <use :href="`${IconsUrl}#add`" />
      </svg>
    </BaseButton>
  </header>
</template>

<style lang="scss" scoped>
@use "@/assets/styles/bootstrap";

.header {
  --line-height-header: 1.375;

  display: grid;
  grid-template-columns: repeat(2, max-content) auto;
  row-gap: 1.8rem;
  align-items: center;
  margin-bottom: 7.5rem;

  @include bootstrap.respond-to-small-screen {
    grid-template-columns: repeat(3, auto);
    row-gap: 3rem;
    margin-bottom: 4.5rem;
  }
}

.logo {
  display: flex;
  align-items: center;
  column-gap: 1.2rem;
  margin-right: 3.5rem;

  @include bootstrap.respond-to-semi-small-screen {
    margin-right: 3rem;
  }

  &__icon {
    width: 3.3rem;
    height: 2.7rem;
    fill: var(--color-dark);
  }

  &__text {
    color: var(--color-dark);
    font-size: 3.6rem;
    font-weight: 700;
    line-height: 1;
  }
}

.search {
  --icon-width: 3.2rem;
  --icon-margin: 1.2rem;

  display: grid;
  grid-template-columns: var(--icon-margin) var(--icon-width) 1fr;
  align-items: center;

  @include bootstrap.respond-to-small-screen {
    grid-row: 2 / span 1;
    grid-column: 1 / -1;
  }

  &__icon {
    grid-column: 2 / span 1;
    grid-row: 1 / span 1;
    width: 100%;
    aspect-ratio: 1;
    fill: var(--color-grey-light);
  }

  &__input {
    grid-column: 1 / -1;
    grid-row: 1 / span 1;
    padding: 1.8rem var(--icon-margin) 1.8rem
      calc(var(--icon-width) + var(--icon-margin) * 2);
    border: 1px solid var(--color-grey-light);
    filter: drop-shadow(0 1px 0.6rem var(--color-dark-shadow-ligh));
    border-radius: 1.2rem;
    font-weight: 500;
    line-height: var(--line-height-header);
    color: var(--color-grey-dark);
    caret-color: var(--color-grey-dark);

    &::placeholder {
      color: var(--color-grey-light);
    }

    &:focus {
      border-color: var(--color-dark);
      outline: solid 0.25rem var(--color-dark);
    }
  }
}

.button {
  background-color: var(--color-success);
  box-shadow: var(--box-shadow-size) var(--color-success-shadow-light);
  margin-left: auto;

  @include bootstrap.respond-to-small-screen {
    grid-column: 3 / span 1;
  }

  &--with-text {
    width: 14rem;
    height: 5.5rem;
    background-color: var(--color-success);
    box-shadow: var(--box-shadow-size) var(--color-success-shadow-light);
    font-weight: 700;
    margin-left: auto;
  }

  &--with-icon {
    padding: 1.2rem;
  }

  &__icon {
    width: 4.3rem;
    height: 4.3rem;
    fill: var(--color-light);
  }
}
</style>
